// Dinamica O(n * n)
// Constantin Galatan
#include <fstream>
#include <algorithm>
using namespace std;
#define DIM 1000001
#define INF 0x3f3f3f3f
ifstream fin("salturi.in");
ofstream fout("salturi.out");

int p[DIM];   // poz maxima in sir la care pot ajunge din poz i, daca fac un salt de j pozitii
int a[DIM], n;

int main()
{
    int last_positive;
    fin >> n;
    for ( int i = 0; i < n; ++i )
    {
        fin >> a[i];
        if ( a[i] > 0 )
            last_positive = i;
        p[i] = INF;
    }

    int i, j, minim;

    for ( i = last_positive; i >= 0; --i )
    {
        if ( a[i] < 0 ) continue;
        if ( i + a[i] < last_positive ) continue;
        last_positive = i;
        if ( i + a[i] > n - 1 )
            p[i] = 1;
        else
        {
            for (minim = INF, j = i + 1; j <= i + a[i] && j < n; ++j )
                minim  = min(minim, p[j]);
            p[i] = 1 + minim;
        }
    }
    if ( p[0] == INF )
        fout << "-1\n";
    else
        fout << p[0] << '\n';
    fin.close();
    fout.close();
    return 0;
}

