// Recursie cu memorizare
// Constantin Galatan
#include <fstream>
using namespace std;
#define DIM 1000001
#define INF 0x3f3f3f3f
ifstream fin("salturi.in");
ofstream fout("salturi.out");

int nrmin[DIM];   // poz maxima in sir la care pot ajunge din poz i, daca fac un salt de j pozitii
int a[DIM], n;
int NrSalt(int i);
int p;
int main()
{
    fin >> n;
    for ( int i = 0; i < n; ++i )
    {
        fin >> a[i];
        nrmin[i] = INF;
    }
    int sol = NrSalt(0);
    if ( sol == INF )
        fout << "-1\n";
    else
        fout << sol << '\n';
    fin.close();
    fout.close();
    return 0;
}

int NrSalt(int i)
{
    if ( i >= n ) return 0;
    int res = INF;
    if ( nrmin[i] != INF )
        return nrmin[i];

    if ( a[i] < 0 ) return INF; // ???

    for ( int s = 1; s <= a[i]; ++s )
        res = min(res, 1 + NrSalt(i + s));
    return nrmin[i] = res;
}
