#include <cstring>
#include <fstream>
#include <algorithm>
using namespace std;

ifstream fin("smsm.in");
ofstream fout("smsm.out");

int D, T, P, Q;
int num[502][502], val[502][502], maxs[502][502];
int res;

// maxs[i][j] = suma maxima cu 2-uri <= i si cu 3-uri >= j

int main()
{
    fin >> D >> T >> P >> Q;

    val[0][0] = 1;
    num[0][0] = 1 * P % Q;

    for (int i = 0; i <= D; ++i)
        for (int j = 0; j <= T; ++j)
            if (i + j != 0)
            {
                if (i != 0) val[i][j] = val[i - 1][j] * 2 % 10;
                else        val[i][j] = val[i][j - 1] * 3 % 10;

                num[i][j] = val[i][j] * P % Q;
            }

    for (int i = 0; i <= D; ++i)
        for (int j = T; j >= 0; --j)
        {
            maxs[i][j] = num[i][j] + (i == 0 || j == T ? 0 : maxs[i - 1][j + 1]);
            maxs[i][j] = max(maxs[i][j], (i == 0 ? 0 : maxs[i - 1][j]));
            maxs[i][j] = max(maxs[i][j], (j == T ? 0 : maxs[i][j + 1]));

            result = max(result, maxs[i][j]);
        }

    fout << result << '\n';

    fin.close();
    fout.close();
}
