# include <fstream>
# include <string>
# include <cstring>
# include <algorithm>
using namespace std;

ifstream f("fibosir.in");
ofstream g("fibosir.out");

int N, K, L;
string str;
char a[2000], b[2000], c[2000], s[500001];

void add(char *a, char *b, char *c)
{
    int i = 0 , j = 0, la = strlen(a), lb = strlen(b);
    int x, k, t;

    x = k = t = 0;
    while (i < la && j < lb)
    {
        x = (a[i] - 48) + (b[j] - 48) + t;
        c[k] = (x % 10) + 48;
        t = x/10;
        ++i; ++j; ++k;
    }
    while (i < la)
    {
        x = (a[i] - 48) + t;
        c[k] = (x % 10) + 48;
        t = x/10;
        ++i; ++k;
    }
    while (j < lb)
    {
        x = (b[j] - 48) + t;
        c[k] = (x % 10) + 48;
        t = x/10;
        ++j; ++k;
    }
    if (t)
    {
        c[k] = t + 48;
        ++k;
    }
    c[k] = '\0';
}

int main()
{
    int i;
    bool ok;

    f >> N >> K;
    //construim fibosir(n)
    a[0] = b[0] = s[0] = s[1] = '1';
    a[1] = b[1] = s[2] = '\0';
    for (i=2; i<N; ++i)
    {
        add(a, b, c);
        strcpy(a, b);
        strcpy(b, c);
        reverse(c, c + strlen(c));
        strcat(s, c);
    }

    str = s; L = K;
	g << s;
    ok = false;
    do {
        string aux = str;
        ok = false;
        for(int i = 0; i < (int)aux.size() - L && !ok; ++i )
        {
            if(aux[i] < aux[i + L])
            {
                str.erase(str.begin() + i, str.begin() + i + L);
                ok = true;
            }
        }
        K--;
    } while(K > 0 && ok);

    g << str << "\n";
    return 0;
}
