// O(N^2 * K)
// Constantin Galatan
#include <fstream>
#include <iostream>
using namespace std;
ifstream fin("sumk.in");
ofstream fout("sumk.out");

#define DIM 201
#define MOD 578537
int N, K;
int C[DIM*DIM + DIM][DIM];

int main()
{
    fin >> N >> K;

    for ( int i = 1; i <= N * K + N - 1; ++i )
    {
        C[i][0] = 1;
        if ( i <= N ) C[i][i] = 1;
    }
    for ( int i = 2; i <= N * K + N - 1; ++i )
        for ( int j = 1; j < i && j < N; ++j )
        {
            C[i][j] = (C[i][j] + C[i-1][j]) % MOD;
            C[i][j] = (C[i][j] + C[i-1][j-1]) % MOD;
        }
    fout << C[N * K + N - 1][N - 1] << '\n';

    fin.close();
    fout.close();
    return 0;
}
