/*
	sursa sortare O(n2) + cautare binara
*/
# include <cstdio>
# define NMax 100003
using namespace std;

struct interval
{
    long long a, b;
} v[NMax], aux;
int N, k, ok;
long long i, j, m;

int cmp (interval x, interval y)
{
    return (x.a <= y.a);
}
inline int intersectie(interval x, interval y, long long m)
{
    x.a = x.a - m; y.a = y.a - m;
    x.b = x.b + m; y.b = y.b + m;
    if (x.b < y.a || y.b < x.a) return 0;
    return 1;
}
int este (long long x)
{
    int i, nr = 1;
    for (i = 1; i<N; ++i)
    {
        if (intersectie(v[i], v[i+1], x))
        {
            ++nr;
            if (nr >= k) return 1;
        }
        else nr = 1;
    }
    return 0;
}
int main()
{
    freopen ("intervale.in", "r", stdin);
    freopen ("intervale.out", "w", stdout);

    scanf("%d %d", &N, &k);
    for (i=1; i<=N; ++i)
        scanf("%lld %lld", &v[i].a, &v[i].b);
    m = N;
    do
    {
        ok = 1;
        for (i=1; i<m; ++i)
            if (!cmp(v[i], v[i+1]))
            {
                ok = 0;
                aux = v[i]; v[i] = v[i+1]; v[i+1] = aux;
            }
        --m;
    }while (!ok);

    i = 1; j = 1500000000;
    while (i <= j)
    {
        m = i + ((j - i) >> 1);
        if (este(m)) j = m - 1;
                else i = m + 1;
    }
    printf("%lld\n", i);
    return 0;
}
