#include <fstream>
#include <algorithm>
#define DIM 2510
#define DIMK 50010
#define INF 1<<29

using namespace std;

inline int minim(int a, int b, int c, int d) {
    return (a < b ? a : b) < (c < d ? c : d) ? (a < b ? a : b) : (c < d ? c : d);
}

struct punct {
    int i;
    int j;
    int t;
};

punct P[DIMK];

char A[DIM][DIM];
int D[DIM][DIM];
int n,m,i,j,k,aux,i1,i2,j1,j2,sum,ok;

int cmpi (const punct &a, const punct &b) {
    return a.i<b.i;
}

int cmpj (const punct &a, const punct &b) {
    return a.j<b.j;
}

int main() {
    ifstream fin("labir.in");
    ofstream fout("labir.out");
    fin>>n>>m;
    fin>>i1>>j1>>i2>>j2;
    fin>>k;
    for (i=1;i<=k;i++) {
        fin>>P[i].i>>P[i].j;
    }
    k++;P[k].i = i1;P[k].j = j1;P[k].t = 1;
    k++;P[k].i = i2;P[k].j = j2;P[k].t = 2;

    sort(P+1, P+k+1, cmpi);

    sum = 0;
    for (i=1;i<=k;i++) {
        if (P[i].i - sum - P[i-1].i >=2)
            sum+= (P[i].i - sum - P[i-1].i - 1);
        P[i].i -= sum;
        if (P[i].t == 1) {
            i1 = P[i].i;
            j1 = P[i].j;
        }
        if (P[i].t == 2) {
            i2 = P[i].i;
            j2 = P[i].j;
        }
    }
    n = P[k].i;

    sort(P+1, P+k+1, cmpj);
    sum = 0;
    for (i=1;i<=k;i++) {
        if (P[i].j - sum - P[i-1].j >=2)
            sum+= (P[i].j - sum - P[i-1].j - 1);
        P[i].j -= sum;
        if (P[i].t == 1) {
            i1 = P[i].i;
            j1 = P[i].j;
        }
        if (P[i].t == 2) {
            i2 = P[i].i;
            j2 = P[i].j;
        }
    }
    m = P[k].j;

    for (i=1;i<=k;i++) {
        if (P[i].t == 0) {
            A[P[i].i][P[i].j] = 1;
        }
    }
    for (i=0;i<=n+1;i++)
        for (j=0;j<=m+1;j++)
            D[i][j] = INF;
    D[i1][j1] = 0;

    do {
        ok = 1;
        for (i=1;i<=n;i++)
            for (j=1;j<=m;j++) {
                aux = minim(D[i-1][j], D[i+1][j], D[i][j-1], D[i][j+1]);
                if (aux + A[i][j] < D[i][j]) {
                    D[i][j] = aux + A[i][j];
                    ok = 0;
                }
            }
    } while (ok == 0);
    fout<<D[i2][j2]<<"\n";
    return 0;
}
