#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <queue>
#include <iomanip>
using namespace std;

#define INF 0x3f3f3f3f
#define mp make_pair
#define pb push_back
typedef pair<int, int> PI;
typedef vector<int> VI;

ifstream fin("labir.in");
ofstream fout("labir.out");

int k; // nr de puncte
VI sx, sy;
VI x, y;
int n, m, xi, yi, xf, yf;
bool A[5001][5001];
VI c[5001];
queue<PI> Q;

void WriteMatr(bool a[][1000], int N, int M)
{
	for ( int i = 1; i <= N; ++i )
	{
		for ( int j = 1; j <= M; ++j )
			fout << setw(3) << a[i][j];
		fout << '\n';
	}
	fout << '\n';
}

void WriteMatr(VI a[], int N, int M)
{
	for ( int i = 1; i <= N; ++i )
	{
		for ( int j = 1; j <= M; ++j )
			fout << setw(3) << a[i][j];
		fout << '\n';
	}
	fout << '\n';
}

void BF();

int main()
{
    fin >> n >> m >> xi >> yi >> xf >> yf;
    fin >> k;
    int a, b;
    for ( int i = 0; i < k; ++i )
    {
        fin >> a >> b;
        A[a][b] = 1;  // numai pentru verificare
    }

 //   WriteMatr(A, m, m);
    for (int i = 1; i <= n; ++i )
        c[i].resize(m + 1, INF);

    BF();
 //   fout << "\nCostul minim: ";
    fout << c[xf][yf] << '\n';
 //   WriteMatr(c, n, m);
    fin.close();
    fout.close();
    return 0;
}

bool Inside(int i, int j)
{
	return i >= 1 and i <= n and j >= 1 and j <= m;
}

const int di[] = { -1, 0, 1, 0},
		  dj[] = { 0, 1, 0, -1 };

void BF()
{
	int iv, jv, i, j;
	PI pi;
	c[xi][yi] = 0;
	Q.push(mp(xi, yi));
	while ( !Q.empty() )
	{
		pi = Q.front(); Q.pop();
		i = pi.first, j = pi.second;
		for (int d = 0; d < 4; ++d )
		{
			iv = i + di[d], jv = j + dj[d];
			if ( Inside(iv, jv) and c[iv][jv] > c[i][j] + A[iv][jv])
			{
				c[iv][jv] = c[i][j] + A[i][j];
				Q.push(mp(iv, jv));
			}
		}
	}
}

