function decl(){
	this.decCache=[];
	this.decCases=[2,  0,  1,  1,  1,  2];
	this.words={
		ww: ['', '', ''],
		dd: ['', '', ''],
		hh: ['', '', ''],
		mm: ['', '', ''], 
		ss: ['', '', '']
	};
	this.d8n=function(i, t){
		if (i==0 || !this.words[t]) return '';
		if(!this.decCache[i]) this.decCache[i] = i % 100 > 4 && i % 100 < 20 ? 2 : this.decCases[Math.min(i % 10,  5)];
		return i + ' ' + this.words[t][this.decCache[i]];
	};
}

var decler=new decl;

var m=60;
var h=3600;
var d=86400;
var w=7*86400;

function ttimer(server_time,running){
	var local_now=new Date();
	this.offset=server_time-local_now.getTime();
	this.event_running=running;
	this.countdown=function(ms) {
		var self=this;
		var Today=new Date();
		var Target=new Date(ms);
		var diff=(Target.getTime()-Today.getTime()-this.offset)/1000;
		var total_diff=diff;
		var weeks=Math.floor(diff/w);
		diff=diff-weeks*w;
		var days=Math.floor(diff/d);
		diff=diff-days*d;
		var hours=Math.floor(diff/h);
		diff=diff-hours*h;
		var minutes=Math.floor(diff/m);
		diff=diff-minutes*m;
		var seconds=Math.floor(diff);
		var str='';
		var tm=20000;
		if(weeks > 0){
			str = decler.d8n(weeks, 'ww') + (days > 0 ? '  ' + decler.d8n(days, 'dd') : '');
		} else {
			if(days > 0){
				str = decler.d8n(days,'dd') + (hours > 0 ? '  ' + decler.d8n(hours, 'hh') : '');
			} else {
				if(hours){
					str = decler.d8n(hours, 'hh') + (minutes > 0 ? '  ' + decler.d8n(minutes, 'mm') : '');
				}else{
					str = (minutes > 0 ? decler.d8n(minutes, 'mm') : ' ');
				}
				tm=5000;
			}
		}
		if(document.getElementById('countdown')){
			document.getElementById('countdown').innerHTML=str;
		}
		if(total_diff<10){
			if(this.event_running){	//    ,    . 
				window.setTimeout(function(){end_contest()}, total_diff*1000);
			}else{
				if(document.getElementById('countdown')){
					window.setTimeout(function(){window.location.reload()}, (3+total_diff)*1000+Math.random()*5000);
				}
			}
		} else {
			window.setTimeout(function(){self.countdown(ms)}, tm);
		}
	}
}

function end_contest(){
	document.getElementById('header_info_line').innerHTML=" !";
	alert(" !");
}

$(function(){
	$("a[rel='external'][href]").each(function(){this.target="_blank"});

	$('.jcarousel').jcarousel({
		scroll:	1,
		visible:	4,
		animation:	'slow',
		imageLoading: '/images/lightbox-ico-loading.gif',
		imageBtnPrev: '/images/lightbox-btn-prev.gif',
		imageBtnNext: '/images/lightbox-btn-next.gif',
		imageBtnClose: '/images/lightbox-btn-close.gif',
		imageBlank: '/images/lightbox-blank.gif'
	});
	$('.lightboxgallery a').lightBox();
	$('.lightboxvideogallery a').lightBoxVideo();
	
	$(".enter .inputs input").focus(function(){	//          
		$(this).removeClass("text");
	}).blur(function(){
		if(!$(this).val()){
			$(this).addClass("text");
		}
	});

});
