#include <stdio.h>

#define DEBUG 0
#define NMAX 111111

int v[NMAX];
int N, K;
long long S;

void ReadInput() {
    int i;

    freopen("secvbest.in", "r", stdin);
    scanf("%d %d %lld", &N, &K, &S);
    for (i = 1; i <= N; i++)
        scanf("%d", &(v[i]));
}

#define INF 1000000000000000000LL

long long cmin[2][NMAX], sp[NMAX], dqv[2][NMAX], tmp;
int li[2], ls[2], dqpoz[2][NMAX];

void Solve() {
    int i, j, k, curr, prev;

    for (i = 1; i <= N; i++)
        cmin[0][i] = INF;
    cmin[0][0] = 0;

    sp[0] = 0;
    for (i = 1; i <= N; i++)
        sp[i] = sp[i - 1] + v[i];

    freopen("secvbest.out", "w", stdout);

    for (curr = prev = 0, k = 1; k <= K; k++) {
        prev = curr;
        curr = 1 - curr;

        cmin[curr][0] = INF;
        li[0] = 0; ls[0] = -1;
        dqv[1][li[1] = ls[1] = 0] = cmin[prev][0] + sp[0];
        dqpoz[1][0] = 0;

        for (i = j = 1; i <= N; i++) {
            cmin[curr][i] = INF;

            while (sp[i] - sp[j - 1] > S) {
                if (li[1] <= ls[1] && dqpoz[1][li[1]] == j - 1) {
                    li[1]++;
                    tmp = cmin[prev][j - 1] - sp[j - 1];
                    while (li[0] <= ls[0] && dqv[0][ls[0]] >= tmp)
                        ls[0]--;
                    ls[0]++;
                    dqv[0][ls[0]] = tmp;
                    dqpoz[0][ls[0]] = j - 1;
                }
                j++;
            }

            if (DEBUG)
                fprintf(stderr, "k=%d i=%d j=%d: %lld %lld: %d_%d %d_%d\n", k, i, j, sp[i] - sp[j - 1], S, li[1], ls[1], li[0], ls[0]);

            if (li[1] <= ls[1]) {
                tmp = dqv[1][li[1]] - sp[i] + S;
                if (tmp < cmin[curr][i])
                    cmin[curr][i] = tmp;
            }

            if (li[0] <= ls[0]) {
                tmp = dqv[0][li[0]] + sp[i] - S;
                if (tmp < cmin[curr][i])
                    cmin[curr][i] = tmp;
            }

            if (DEBUG)
                fprintf(stderr, "k=%d i=%d: cmin=%lld\n", k, i, cmin[curr][i]);

            tmp = cmin[prev][i] + sp[i];
            while (li[1] <= ls[1] && dqv[1][ls[1]] >= tmp)
                ls[1]--;
            ls[1]++;
            dqv[1][ls[1]] = tmp;
            dqpoz[1][ls[1]] = i;
        }

        printf("%lld", cmin[curr][N]);
        if (k < K)
            printf(" ");
    }

    printf("\n");
}

int main() {
    ReadInput();
    Solve();
    return 0;
}