#include <stdio.h>

#define KMAX 31

int bit[KMAX];

void ComputeBits() {
	int i;
	bit[0] = 1;
	for (i = 1; i < KMAX; i++)
		bit[i] = bit[i - 1] * 2;
}

long long nfull[KMAX];

void ComputeFull() {
	nfull[0] = 1;
	int i;
	for (i = 1; i < KMAX; i++) {
		nfull[i] = nfull[i - 1] * 3;
	}
}

long long Count(int K, int A, int B) {
	if (K == 0)
		return 1;

	if (A == 0 && B == bit[K] - 1)
		return nfull[K];
	
	long long answer = 0;
	
	if (A <= bit[K - 1] - 1 && B <= bit[K - 1] - 1)
		answer += 2 * Count(K - 1, A, B);

	if (A <= bit[K - 1] - 1 && B >= bit[K - 1])
		answer += 2 * Count(K - 1, A, bit[K - 1] - 1);
	
	if (A >= bit[K - 1] && B >= bit[K - 1])
		answer += Count(K - 1, A - bit[K - 1], B - bit[K - 1]);

	if (A <= bit[K - 1] - 1 && B >= bit[K - 1])
		answer += Count(K - 1, 0, B - bit[K - 1]);

	return answer;
}

int main() {
	int te, T, K, A, B;

	ComputeBits();
	ComputeFull();

	scanf("%d", &T);
	
	for (te = 1; te <= T; te++) {
		scanf("%d %d %d", &K, &A, &B);
		A--; B--;
		printf("Case %d: %lld\n", te, Count(K, A, B));
	}
	
	return 0;
}
