#include <stdio.h>
#include <algorithm>

using namespace std;

#define NMAX 2010
#define INF 1000000000000000ULL

unsigned long long cmin[NMAX][4], saj, sbj, eaj, ebj, sai, sbi, eai, ebi;
int x[NMAX], a[NMAX], b[NMAX];
int N, i, j, p, q;

int main() {
	freopen("metrou.in", "r", stdin);
	scanf("%d", &N);
	for (i = 1; i <= N; i++)
		scanf("%d", &x[i]);
	for (i = 1; i <= N; i++)
		scanf("%d", &a[i]);
	for (i = 1; i <= N; i++)
		scanf("%d", &b[i]);

	for (i = 1; i <= N; i++)
		for (p = 0; p < 4; p++)
			cmin[i][p] = INF;
	
	cmin[0][0] = cmin[0][1] = cmin[0][2] = cmin[0][3] = 0;

	for (i = 1; i <= N; i++) {
		saj = a[i]; sbj = b[i];
		eaj = ebj = 0;

		if (i < N) {
			eai = a[i] * (x[i + 1] - x[i]);
			ebi = b[i] * (x[i + 1] - x[i]);
		}

		for (j = i - 1; j >= 0; j--) {
			if (j > 0) {
				eaj += saj * (x[j + 1] - x[j]);
				ebj += sbj * (x[j + 1] - x[j]);
				saj += a[j];
				sbj += b[j];

				cmin[i][1] = min(cmin[i][1], min(cmin[j][2], cmin[j][3]) + ebj);
				cmin[i][3] = min(cmin[i][3], min(cmin[j][0], cmin[j][1]) + eaj);
			}

			if (i < N) {
				cmin[i][0] = min(cmin[i][0], cmin[j][1] + ebi);
				cmin[i][2] = min(cmin[i][2], cmin[j][3] + eai);

				cmin[i][0] = min(cmin[i][0], min(cmin[j][2], cmin[j][3]) + ebi);
				cmin[i][2] = min(cmin[i][2], min(cmin[j][0], cmin[j][1]) + eai);

				eai += a[j] * (x[i + 1] - x[j]);
				ebi += b[j] * (x[i + 1] - x[j]);
			}
		}
	}

	/*
	for (i = 1; i <= N; i++)
		for (p = 0; p < 4; p++) {
			fprintf(stderr, "i=%d p=%d: %llu\n", i, p, cmin[i][p]);
		}
	*/

	freopen("metrou.out", "w", stdout);
	printf("%llu\n", min(cmin[N][1], cmin[N][3]));

	return 0;
}
