// Recursie cu memorizare
// Constantin Galatan
#include <cstdio>
#include <algorithm>
#include <climits>
using namespace std;

#define DIM 1000001
#define INF USHRT_MAX - 1

unsigned short nrmin[DIM];   // nrmin[i] = nr min de salturi incepand cu poz i
int a[DIM], n, p;
unsigned short NrSalt();

int main()
{
    freopen("salturi.in", "r", stdin);
    freopen("salturi.out", "w", stdout);
    scanf("%d", &n);
    for ( int i = 0; i < n; ++i )
    {
        scanf("%d", a + i);
        nrmin[i] = INF;
    }

    int sol = NrSalt();
    if ( sol == INF )
        printf("-1\n");
    else
        printf("%d\n", sol);
    fclose(stdin);
    fclose(stdout);
    return 0;
}

unsigned short NrSalt()
{
    if ( p >= n ) return 0;
    if ( nrmin[p] != INF )
        return nrmin[p];
    if ( a[p] < 0 ) return INF; // ???
    unsigned short res = INF;
    for ( int s = 1; s <= a[p]; ++s )
    {
        p += s;
        res = min(res, (unsigned short)(1 + NrSalt()));
        p -= s;
    }
    return nrmin[p] = res;
}
