#include <fstream>
#include <vector>
#include <algorithm>
#define DIM 200100
#define INF 1LL<<62
using namespace std;

struct platforma {
    int h;
    int x1;
    int x2;
};

long long M[DIM];
int F[200100];
vector<int> L[DIM];
int hm,xm,H,i,j,n;
platforma P[DIM];

int cmp(const platforma &p1, const platforma &p2) {
    return p1.h < p2.h;
}

void dinamica(int n) {
    if (n == 1) {
        M[n]=1;
        return;
    }

    if (M[n] != INF) {
        return;
    }

    long long r = 0;
    for (int i=0;i<L[n].size();i++) {
        dinamica(L[n][i]);
        r += M[L[n][i]];
    }
    M[n] = r;
    //return r;
}

int main() {
    ifstream fin("mario.in");
    ofstream fout("mario.out");
    fin>>hm>>xm>>H;
    fin>>n;

    for (i=1;i<=n;i++) {
        fin>>P[i].h>>P[i].x1>>P[i].x2;
    }


    P[++n].h = 0;
    P[n].x1 = 0;
    P[n].x2 = 200000;

    P[++n].h = hm;
    P[n].x1 = xm;
    P[n].x2 = xm;

    sort(P+1, P+n+1, cmp);

    for (i=1;i<=n;i++)
        M[i] = INF;

    for (i=0;i<=200000;i++)
        F[i] = 1;

    for (i=2;i<=n;i++) {

        if (P[i].h - P[F[   P[i].x1  ]].h <= H) {
            L[i].push_back(F[P[i].x1]);
        }
        if (P[i].h - P[F[   P[i].x2  ]].h <= H) {
            L[i].push_back(F[P[i].x2]);
        }

        for (j=P[i].x1;j<=P[i].x2;j++) {
            F[j] = i;
        }
    }

    dinamica(n);

    fout<<M[n]/2<<"\n";

    return 0;
}
