# include <fstream>
# include <algorithm>
# define NMax 100003
using namespace std;

ifstream f("intervale.in");
ofstream g("intervale.out");
struct interval
{
    long long a, b;
} v[NMax], aux;
int N, P, ok;
long long i, j, m;

int cmp (interval x, interval y)
{
    if (x.a > y.a) return 0;
    else if (x.a == y.a && x.b <= y.b) return 0;
    return 1;
}
inline int intersectie(interval x, interval y, long long m)
{
    x.a = x.a - m; y.a = y.a - m;
    x.b = x.b + m; y.b = y.b + m;
    if (x.b < y.a || y.b < x.a) return 0;
    return 1;
}

int este (long long x)
{
    int i, nr = 1;
    for (i=1; i<N; ++i)
    {
        if (intersectie(v[i], v[i+1], x))
        {
            ++nr;
            if (nr >= P) return 1;
        }
        else nr = 1;
    }
    return 0;
}
int main()
{
    f >> N >> P;
    for (i=1; i<=N; ++i)
        f >> v[i].a >> v[i].b;

    sort (v + 1, v + N + 1, cmp);

    i = 1; j = 1500000000;
    while (i <= j)
    {
        m = i + ((j - i) >> 1);
        if (este(m)) j = m - 1;
                else i = m + 1;
    }
    g << i << '\n';
    return 0;
}
