#include <fstream>
#include <algorithm>
#define DIM 100010

using namespace std;

struct inter {
    long long st;
    long long dr;
};

long long n, x, p, u, P, m, i, st, dr;

inter v[DIM];

int cmp(const inter &a, const inter &b) {
    return a.st < b.st;
}

int trece (long long x) {

    for (i=1;i<=n;i++) {
        v[i].st -= x;
        v[i].dr += x;
    }

    long long st = v[1].st;
    long long dr = v[1].dr;
    long long nr = 1;
    long long ok = 0;

    sort(v+1, v+n+1, cmp);

    for (i=2;i<=n&&!ok;i++) {
        if (v[i].st <= dr) {
            nr++;
            if (nr >= P) {
                ok = 1;
                break;
            }
            if (v[i].dr > dr)
                dr = v[i].dr;
        } else {
            st = v[i].st;
            dr = v[i].dr;
            nr = 1;
        }
    }

    for (i=1;i<=n;i++) {
        v[i].st += x;
        v[i].dr -= x;
    }

    return ok;
}

int main() {
    ifstream fin("intervale.in");
    ofstream fout("intervale.out");
    fin>>n>>P;
    for (i=1;i<=n;i++) {
        fin>>v[i].st>>v[i].dr;
    }

    sort(v+1, v+n+1, cmp);

    st = 1;
    dr = 2000000000;
    while (st<=dr) {
        m = st + (dr-st)/2;
        if (trece(m)) {
            dr = m-1;
        } else {
            st = m+1;
        }

    }

    fout<<st<<"\n";
    return 0;
}
